#!/usr/bin/perl
###
$FeedURL='';#Feedのアドレス。RSS1.0、RSS2.0、Atomに対応。
$UpdateInterval=0.1;#チェック間隔。単位=日。少数可。
$Charset='';#Feedの文字コードを設定。'euc-jp' 'shiftjis' とか。utf8の場合は空で。
$LinkTarget='_blank';#別ウインドウなら'_blank' 同じウインドウなら'_self'
$ListMax=20;#リストに登録する最大数。
###
&GetFeed if(!-s("list.dat") || -M("list.dat")>$UpdateInterval);
open(FILE,"list.dat");
flock(FILE,1);
while(<FILE>){
	next if(/^\s+$/);
	s/[\\']/\\$1/g;
	s/[\r\n]//g;
	$list.="TickerItem.push('$_');\n";
}
close(FILE);
$script=<<"EOF";
var TickerItem=[];
$list
var TickerArea=document.getElementById("TickerArea");
var TickerWidth=parseInt(TickerArea.style.width) || 468;
TickerArea.style.position="relative";
TickerArea.style.overflow="hidden";
TickerArea.style.width=TickerWidth+"px";
TickerChange(0);
function TickerChange(n){
	if(!TickerItem[n]) n=0;
	TickerArea.removeChild(document.getElementById("TickerItem"));
	var div=document.createElement("div");
	div.innerHTML=TickerItem[n];
	div.id="TickerItem";
	div.style.position="absolute";
	TickerArea.appendChild(div);
	TickerMove(n,TickerWidth,0);
}
function TickerMove(n,l,t){
	l-=10;
	if(l<0) l=0;
	document.getElementById("TickerItem").style.left=l+"px";
	document.getElementById("TickerItem").style.top=t+"px";
	if(l==0 && t==0){
		window.setTimeout("TickerMove("+n+","+0+","+1+")",7000);
		return;
	}
	if(t>0) t++;
	if(t>20){
		TickerChange(n+1);
		return;
	}
	window.setTimeout("TickerMove("+n+","+l+","+t+")",100);
}
EOF
print "content-type:text/javascript\n\n$script";
###
sub GetFeed{
	my($ua,$res,$req,$get,$item,$str,$link,$title,$list,$count,$script);
	use LWP::UserAgent;
	use Encode;
	$ua=LWP::UserAgent->new;
	$req=HTTP::Request->new(GET=>$FeedURL);
	$res=$ua->request($req);
	$get=$res->content;
	Encode::from_to($get,'shiftjis','utf8') if($Charset);
	$item='item';
	$item='entry' if($get=~/<\/feed>/);
	while($get=~/<$item[^>]*>(.+?)<\/$item>/sg){
		$str=$1;
		($link)=$str=~/<link>([^<]+)<\/link>/;
		($link)=$str=~/<link [^>]*href=["']([^<"']+)["']\/>/ if(!$link);
		($title)=$str=~/<title>([^<]+)<\/title>/;
		$link=~s/[\\']/\\$1/g;
		$title=~s/[\\']/\\$1/g;
		$title=~s/[\r\n]+/ /g;
		$list.="<a href=\"$link\" target=\"$LinkTarget\">$title</a>\n" if($link && $title);
		$count++;
		last if($count==$ListMax);
	}
	open(FILE,"+>list.dat");
	flock(FILE,2);
	print FILE $list;
	close(FILE);
}
###

